"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class IndividualState(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "state",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import metrics as metrics_1_2_2

        return {
            "reason": metrics_1_2_2.Reason,
            "state": metrics_1_2_2.State,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.Reason": metrics_1_2_2.Reason,
            "org.gel.models.report.avro.State": metrics_1_2_2.State,
            "org.gel.models.report.avro.IndividualState": metrics_1_2_2.IndividualState,
        }

    __slots__ = [
        "state",
        "reason",
    ]

    def __init__(
        self,
        state,
        reason=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.IndividualState model.

        :param state:
        :type state: State
        :param reason:
        :type reason: None | Reason
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
